<?php
namespace Zeedhi\DevOps\Model\Configurationmanager\Entities;

use Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer as EntitiesProductServer;
use Zeedhi\DevOps\Model\Util\LogicalDeletedIsActiveColumn;
use Zeedhi\DevOps\Util\Events\Audit\AuditAble;
use Zeedhi\DevOps\Util\Events\Organization\OrganizationAble;

class Subrelease extends \Zeedhi\DevOps\Model\Configurationmanager\Entities\Base\Subrelease
    implements OrganizationAble, AuditAble, LogicalDeletedIsActiveColumn {

    CONST TESTED_STATUS             = 'O';
    CONST IN_TEST_STATUS            = 'T';
    CONST IN_CONFLICT_STATUS        = 'C';
    CONST PENDING_STATUS            = 'P';
    CONST HOMOLOGATED_STATUS        = 'H';
    CONST PACKAGE_CREATED_STATUS    = 'K';
    CONST IM_HOMOLOGATION_STATUS    = 'I';

    public function isLogicalDeleted()
    {
        return $this->getIsActive() == self::STATUS_LOGICAL_DELETED;
    }
    public function getServerByType($type){
        $server = null;
        if(EntitiesProductServer::TYPE_TEST == $type){
            $server = $this->getProductServer()->getServer();
        }else if($this->getRelease()->getIsFixRelease() == Release::IS_FIX_RELEASE){
            if($this->getRelease()->getProductServer()){
                $server = $this->getRelease()->getProductServer()->getServer();
            }else{
                $server = $this->getProductServer()->getServer();
            }
        }
        return $server;
    }
    public function getProduct(){
        return $this->getRelease()->getProduct();
    }
}